/*----------------------------------------------------------------------------------*/
/*	Copyright (C) Endress+Hauser Metechnik GmbH+Co (2001). All Rights Reserved		*/
/*	Product:		SIMATIC SIPROM													*/
/*                                                    								*/
/*	Device:			PROMAG 3x for PROFIBUS PA										*/
/*	Description:	Device Description												*/
/*	Dictionary:		SIPADC01.dct													*/
/*                                                         							*/
/*  $Revision:1.5$									*/
/*  $Date: 12.02.2002									*/
/*  Obere Revision fr QVCS, untere fr DD, unten die aktuelle angeben 			*/ 
/*  Revision:1.5									*/
/*  Date: 12.02.2002									*/
/*----------------------------------------------------------------------------------*/
/* Date:                01.06.2001													*/
/* Author:              J. Flegel / ICS GmbH										*/
/* Changed Function(s): Change001 Korrekturen zum Nachtest vom 31.05.01				*/
/*----------------------------------------------------------------------------------*/
/* Date:                12.02.2002													*/
/* Author:              Frank Birgel / E+H PCPS										*/
/* Changed Function(s): herstellerspezifische Parameter aus Profilansicht entfernt
			Kalibrationsdaten nur mit 4685 Code schreibbar zum Gert, RO
			Defaultwerte angepasst
			Onlinedialog Codeeingabe entfernt-> jetzt offline
			MS Abgleich jetz online einstellbar*/
/*----------------------------------------------------------------------------------*/

MANUFACTURER	17,
DEVICE_TYPE		1,
DEVICE_REVISION 0x0200,
DD_REVISION		1

#define C_SYSTEM_OK					0
#define C_POS_ZERO_RET				1
#define C_SIM_ACTIV					2
#define C_SIM_IMP_FRQ_ACTIV			3
#define C_SYS_POWER_SUPLY1			4
#define C_SYS_POWER_SUPLY2			5
#define C_SYS_ERR_AMP1				6
#define C_SYS_ERR_AMP2				7
#define C_SYS_ERR_AMP3				8
#define C_SYS_ERR_AMP4				9
#define C_SYS_ERR_AMP5				10
#define C_SYS_ERR_COM_MODUL1		11
#define C_SYS_ERR_COM_MODUL2		12
#define C_SYS_ERR_COM_MODUL3        13
#define C_SYS_ERR_COM_MODUL4        14
#define C_SYS_ERR_COM_MODUL5		15
#define C_SYS_ERR_COM_MODUL6		16
#define C_VALUE_NOT_USED			17
#define C_EPD_TRIM_MIS				18
#define C_EPD_TRIM_IMPAS			19
#define C_EPD_FULL_EMPTY1           20
#define C_EPD_FULL_EMPTY2           21
#define C_EMP_PIPE					22
#define C_MESURE_LARGE				23
#define C_CURR_OUT_HI_LEVEL         24
#define C_FREQ_OUT_HI_LEVEL         25
#define C_TIME_OVER					26
#define C_EPD_RUN1					27
#define C_EPD_RUN2					28



#define INDEX_phys_message IF(phys_software_rev_numeric > 205) {31;} ELSE {32;}
#define INDEX_phys_install_date IF(phys_software_rev_numeric > 205) {32;} ELSE {31;}




#include "SIPAST_Macros_200.inc"

//Change001 start
#define EXTRA_ITEMS_TAB_S_IDENT_OPUNIT	dummy_message		(HIDDEN),
#define EXTRA_ITEMS_TAB_M_IDENT_OPUNIT	dummy_message		(HIDDEN),
#define EXTRA_ITEMS_TAB_S_IDENT_DEVICE	dummy_message		(HIDDEN),
#define EXTRA_ITEMS_TAB_M_IDENT_DEVICE	dummy_message		(HIDDEN),
#define EXTRA_ITEMS_PAGE_DIAGNOSIS_GENERAL	dummy_message		(HIDDEN),
//Change001 end

#define DEVICE_TITLE	"Promag 3x"
#define DEFAULT_MANUFACTURER_ID	 17
#define CHECK_DEVICE_TYPE "PROMAG PBUS"
#define CHECK_PROFILE_REV	0x200

#define DEFAULT_VALUE_phys_manufacturer_id	 17
#define DEFAULT_VALUE_phys_device_id "PROMAG PBUS"
#define DEFAULT_VALUE_phys_software_rev	"V2.05.03"

#define	EXTRA_ITEMS_VIEW_MENU_SPECIALIST	Menu_S_alarm, OnlineWindow_diagnosis
#define EXTRA_ITEMS_VIEW_MENU_MAINTENANCE	Menu_M_alarm, OnlineWindow_diagnosis

#define DECIMAL_POINT_7_SUPPORTED
#define DECIMAL_POINT_STANDARD_SUPPORTED

#define NO_trans1_sensor_limit

//#define TRANS1_PRIVATE_UNITS
#define TRANS1_PV_UNIT_LIST									  \
		DEFAULT_VALUE	19 ;								  \
		{ 28,	"m/s"										},\
		{ 131,  "m/min"									},\
		{ 19, "m/h"										},\
		{ 24, "L/s"											},\
		{ 17,  "L/min"										},\
		{ 138,  "L/h"										},\	
		{ 241, "hl/min"										},\
		{ 242, "hl/h"										},\
		{ 16, [gal_min],			[gal_min_help]			},\
		{ 136, [gal_hr],			[gal_hr_help]			},\
		{ 235, [gallons_per_day],	[gallons_per_day_help]	},\
		{ 23, [MillionGal_day],		[MillionGal_day_help]	},\
		{ 133, [bbl_min],			[bbl_min_help]			},\
		{ 134, [bbl_hr],			[bbl_hr_help]			},\
		{ 135, [bbl_day],			[bbl_day_help]			},\
		{ 26, "ft/s"										},\
		{ 243, "cc/min"										},

#define TRANS1_FLOWRATE_UNIT_SYNC			func1_pv_unit

#define FUNC1_PV_UNIT_LIST					VOLUME_FLOW_UNITS

#include "SIPAST.inc"

#include "SIPAST_CommError.inc"

#include "SI_FileM.inc"
#include "SI_HlpM.inc"
#include "SI_OptM.inc"
#include "SI_ViewM.inc"



#include "SIPASTPB_200.inc"


// --- Transducer Block Flow Electromagnetic ---
#include "Trans1_Flow_Vol_Electromagnetic_200.inc"


// AI1 ---
#define FUNC1_TITLE [trans_flow_volume_flow]
#define DEFAULT_VALUE_func1_out_unit	138
//#define FUNC1_TITLE [func1_AI]

#define DEFAULT_VALUE_func1_hi_hi_lim 3e38
#define DEFAULT_VALUE_func1_hi_lim 3e38
#define DEFAULT_VALUE_func1_lo_lim -3e38
#define DEFAULT_VALUE_func1_lo_lo_lim -3e38

#include "SIPASTAI1_200.inc"

// TOT2 ---
#define FUNC2_TITLE [menu_output_totalizer_Summenz]
#include "Totalizer2_200.inc"



#define YT1_LABEL		[func_out_value]
#define YT1_VALUE		func1_out_value
#define	YT1_LRV		func1_out_lower_range_value
#define YT1_URV		func1_out_upper_range_value
#include "SI_YT.inc"


// Help Objects ------------------------------------------------------

VARIABLE dummy_message
{
	LABEL		[phys_message];
	HELP		[phys_message_help];
	CLASS		CONTAINED;
	TYPE		ASCII (32);
	HANDLING	READ;
	PRE_READ_ACTIONS
	{
		GetNumericSoftwareRevision,
		meth_read_phys_message
	}
}

COMMAND read_dummy_message
{
	BLOCK physical_block;
	//INDEX INDEX_phys_message ;
	INDEX IF(phys_software_rev_numeric > 205) {31;} ELSE {32;}
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			dummy_message
		}
	}
}

VARIABLE dummy_phys_install_date
{
	LABEL		[phys_install_date];
	HELP		[phys_install_date_help];
	CLASS		CONTAINED;
	TYPE		ASCII (8);
	HANDLING	READ;
	PRE_READ_ACTIONS
	{
		GetNumericSoftwareRevision,
		meth_read_phys_message
	}

}

COMMAND read_dummy_phys_install_date
{
	BLOCK physical_block;
	//INDEX INDEX_phys_message ;
	INDEX IF(phys_software_rev_numeric > 205) {32;} ELSE {31;}
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			dummy_phys_install_date
		}
	}
}

METHOD meth_read_phys_message
{
	LABEL "meth_read_phys_message" ;
	DEFINITION
	{
		//ACKNOWLEDGE ("meth_read_phys_message: phys_software_rev_numeric = %{phys_software_rev_numeric}");
		ReadCommand(read_phys_message) ;
	}
}

// Transducer Block Flow ------------------------------------------------------

VARIABLE trans1_flowrate_private_unit
{
	LABEL		[V0H2_LABEL];	
	HELP		[V0H2_LABEL_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)
	{
		DEFAULT_VALUE	19 ;

		{ 28,	"m/s" },
		{ 131,  "m/min" },
		{ 19, "m/h" },
		{ 24, "L/s" },
		{ 17,  "L/min"},
		{ 138,  "L/h"},	
		{ 241, "hl/min" },
		{ 242, "hl/h" },
		{ 16, [gal_min],				[gal_min_help]						},
		{ 136, [gal_hr],				[gal_hr_help]						},
		{ 235, [gallons_per_day],		[gallons_per_day_help]				},
		{ 23, [MillionGal_day],			[MillionGal_day_help]				},
		{ 133, [bbl_min],				[bbl_min_help]						},
		{ 134, [bbl_hr],				[bbl_hr_help]						},
		{ 135, [bbl_day],				[bbl_day_help]						},
		{ 26, "ft/s",					[bbl_day_help]						},
		{ 243, "cc/min",				[bbl_day_help]						},
	}

	HANDLING	READ & WRITE;

	POST_READ_ACTIONS
	{
		trans1_flowrate_unit_private2profile	
	}
	POST_EDIT_ACTIONS
	{
		trans1_flowrate_unit_private2profile,
		trans1_flowrate_unit_sync
	}
}

METHOD trans1_flowrate_unit_private2profile
{
	LABEL "trans1_flowrate_private_unit" ;
	DEFINITION
	{
#if 0
		int aiUnitCodes[80] ;

		aiUnitCodes[0] = 1512 ; /* cm3 / min */
		aiUnitCodes[1] = 1513 ; /* cm3 / h */
		aiUnitCodes[2] = 24 ; /* l / s */
		aiUnitCodes[3] = 17 ; /* l / min */
		aiUnitCodes[4] = 138 ; /* l / h */
		aiUnitCodes[5] = 24 ; /* l / s	*/
		aiUnitCodes[6] = 17 ; /* l / min */
		aiUnitCodes[7] = 138 ; /* l / h  */
		aiUnitCodes[8] = 999 ; /* */
		aiUnitCodes[9] = 999 ; /* */
		aiUnitCodes[10] = 28 ; /* m3 / s */
		aiUnitCodes[11] = 131 ; /* m3 / min */
		aiUnitCodes[12] = 19 ; /* m3/ h */
		aiUnitCodes[13] = 999 ; /* */
		aiUnitCodes[14] = 999 ; /* */
		aiUnitCodes[15] = 16 ; /* gal/ min */
		aiUnitCodes[16] = 999 ; /* */
		aiUnitCodes[17] = 999 ; /* */
		aiUnitCodes[18] = 999 ; /* */
		aiUnitCodes[19] = 999 ; /* */
		aiUnitCodes[20] = 999 ; /* */
		aiUnitCodes[21] = 136 ; /* gal / h*/
		aiUnitCodes[22] = 999 ; /* */
		aiUnitCodes[23] = 999 ; /* */
		aiUnitCodes[24] = 136 ; /* gal / h */
		aiUnitCodes[25] = 999 ; /* */
		aiUnitCodes[26] = 999 ; /* */
		aiUnitCodes[27] = 235 ; /* gal / day */
		aiUnitCodes[28] = 999 ; /* */
		aiUnitCodes[29] = 999 ; /* */
		aiUnitCodes[30] = 999 ; /* */
		aiUnitCodes[31] = 999 ; /* */
		aiUnitCodes[32] = 999 ; /* */
		aiUnitCodes[33] = 999 ; /* */
		aiUnitCodes[34] = 999 ; /* */
		aiUnitCodes[35] = 999 ; /* */
		aiUnitCodes[36] = 999 ; /* */
		aiUnitCodes[37] = 999 ; /* */
		aiUnitCodes[38] = 999 ; /* */
		aiUnitCodes[39] = 999 ; /* */
		aiUnitCodes[40] = 999 ; /* */
		aiUnitCodes[41] = 999 ; /* */
		aiUnitCodes[42] = 999 ; /* */
		aiUnitCodes[43] = 999 ; /* */
		aiUnitCodes[44] = 999 ; /* */
		aiUnitCodes[45] = 999 ; /* */
		aiUnitCodes[46] = 999 ; /* */
		aiUnitCodes[47] = 999 ; /* */
		aiUnitCodes[48] = 999 ; /* */
		aiUnitCodes[49] = 999 ; /* */
		aiUnitCodes[50] = 999 ; /* */
		aiUnitCodes[51] = 23 ; /* Mgal / day */
		aiUnitCodes[52] = 999 ; /* */
		aiUnitCodes[53] = 999 ; /* */
		aiUnitCodes[54] = 999 ; /* */
		aiUnitCodes[55] = 999 ; /* */
		aiUnitCodes[56] = 999 ; /* */
		aiUnitCodes[57] = 133 ; /* bbl / min*/
		aiUnitCodes[58] = 999 ; /* */
		aiUnitCodes[59] = 999 ; /* */
		aiUnitCodes[60] = 999 ; /* */
		aiUnitCodes[61] = 999 ; /* */
		aiUnitCodes[62] = 999 ; /* */
		aiUnitCodes[63] = 134 ; /* bbl / h */
		aiUnitCodes[64] = 999 ; /* */
		aiUnitCodes[65] = 999 ; /* */
		aiUnitCodes[66] = 999 ; /* */
		aiUnitCodes[67] = 999 ; /* */
		aiUnitCodes[68] = 999 ; /* */
		aiUnitCodes[69] = 135 ; /* bbl / day */
		aiUnitCodes[70] = 999 ; /* */
		aiUnitCodes[71] = 999 ; /* */
		aiUnitCodes[72] = 999 ; /* */
		aiUnitCodes[73] = 999 ; /* */
		aiUnitCodes[74] = 999 ; /* */
		aiUnitCodes[75] = 999 ; /* */
		aiUnitCodes[76] = 999 ; /* */
		aiUnitCodes[77] = 999 ; /* */
		aiUnitCodes[78] = 999 ; /* */
		aiUnitCodes[79] = 0 ; /* */

		trans1_flowrate_unit = aiUnitCodes[ivar_value(trans1_flowrate_private_unit)] ;

#ifdef _V510_
		_TRACE("Converting trans1_flowrate_private_unit(" + itoa(trans1_flowrate_private_unit) 
				+") to trans1_flowrate_unit(" + itoa(trans1_flowrate_unit) + ")") ;
#endif
#endif
		trans1_flowrate_unit = trans1_flowrate_private_unit;

	}
}	

VARIABLE trans1_tb_system_config
{
	LABEL		[trans_act_device_config];		// 
	HELP		[trans_act_device_config_help];		// 
	CLASS		CONTAINED & DYNAMIC;
	TYPE		UNSIGNED_INTEGER(1);
	HANDLING	READ;
}

VARIABLE trans1_tb_totalizer_overflows
{
	LABEL		[trans_tb_totalizer_overflows];		// 
	HELP		[trans_tb_totalizer_overflows_help];	// 
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER(2);
	HANDLING	READ;
}

VARIABLE trans1_tb_unit_diameter
{
	LABEL		[V0H5_LABEL_change];		// 
	HELP		[V0H5_LABEL_change_help];		// 
	CLASS		CONTAINED;
	TYPE		ENUMERATED(2)
	{
		{49, [unit_1013], [unit_1013_help]},
		{47, [unit_1019], [unit_1013_help]},
	}
	HANDLING	READ & WRITE;
}

VARIABLE trans1_tb_pzr
{
	LABEL		[V7H0_LABEL_change];		// 
	HELP		[V7H0_LABEL_change_help];		// 
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		DEFAULT_VALUE	0 ;
		{0, [off]	},
		{1, [on]	},
	}

}
//Bi V1.5 neu eingefgt, hat vorher gefehlt
VARIABLE trans1_tb_epd_responce_time
{
	LABEL		[V8H3_LABEL_change];		// 
	HELP		[V8H3_LABEL_change_help];		// 
	CLASS		CONTAINED;
	TYPE		ENUMERATED(1)
	{
		DEFAULT_VALUE	0 ;
		{0, "1 s"	},
		{1, "2 s"	},
		{2, "5 s"	},
		{3, "10 s"	},
		{4, "30 s"	},
		{5, "1 min"	},
	}

	VALIDITY	IF ((trans1_tb_msue_page == 1)&&(trans1_tb_epd_electrode ==1))

				{
					TRUE;
				}
				ELSE
				{
					FALSE;
				}
	

}



VARIABLE trans1_tb_amp_mode
{
	LABEL		[V8H8_LABEL_change];		// 
	HELP		[V8H8_LABEL_change_help];	// 
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		{	0,  "Automatic|de|Automatisch"	},
		{	1,  "Mode1"		},
		{	2,  "Mode2"		},
		{	3,  "Mode3"		},
		{	4,  "Mode4"		},
	}
	HANDLING	READ & WRITE;
}

VARIABLE trans1_tb_calib_fact_neg
{
	LABEL		[V9H1_LABEL_change];		// 
	HELP		[V9H1_LABEL_change_help];		// 
	CLASS		CONTAINED;
	TYPE		FLOAT;
	HANDLING IF (help_trans1_tb_code_page_loc != 4685)
	{
		READ;
	}
	ELSE
	{
		READ & WRITE;
	}

}

VARIABLE trans1_tb_max_sample_rate
{
	LABEL		[V9H4_LABEL_change];		// 
	HELP		[V9H4_LABEL_change_help];	// 
	CLASS		CONTAINED;
	TYPE		FLOAT;
	HANDLING IF ( help_trans1_tb_code_page_loc!= 4685)
	{
		READ;
	}
	ELSE
	{
		READ & WRITE;
	}

    CONSTANT_UNIT  "Hz";
}

VARIABLE trans1_sample_rate
{
	LABEL		[V9H5_LABEL_change];
	HELP		[V9H5_LABEL_change_help];
	CLASS		CONTAINED;
	TYPE		FLOAT;
	HANDLING IF (help_trans1_tb_code_page_loc != 4685)
	{
		READ;
	}
	ELSE
	{
		READ & WRITE;
	}

    CONSTANT_UNIT  "Hz";
}

VARIABLE trans1_tb_sens_sw_ver
{
	LABEL		[V7H6_LABEL_change];		// 
	HELP		[V7H6_LABEL_change_help];	// 
	CLASS		CONTAINED;
	TYPE		ASCII(16);
	HANDLING	READ;
}

VARIABLE trans1_tb_assign_disp_line1
{
	LABEL		[V5H2_LABEL_change];	
	HELP		[V5H2_LABEL_change_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	1 ;
		{ 1,	[enum_flow]		},
		{ 2,	[enum_totalizer]},
	}
}

VARIABLE trans1_tb_assign_disp_line2
{
	LABEL		[V5H3_LABEL_change];		// 
	HELP		[V5H3_LABEL_change_help];	// 
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	2 ;
		{ 0,	[off]				},
		{ 1,	[enum_flow]			},
		{ 2,	[enum_totalizer]	},
		{ 3,	[enum_tot_overflow]	},
	}

}

VARIABLE trans1_tb_assign_language
{
	LABEL		[V5H7_LABEL_change];	
	HELP		[V5H7_LABEL_change_help];
	CLASS		CONTAINED;
	HANDLING	READ & WRITE;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0 ;
		{ 0,	"English"			},
		{ 1,    "Deutsch"			},
		{ 2,    "Franais"			},
		{ 3,    "Espaol"			},
		{ 4,	"Italiano"			},
		{ 5,    "Nederlands"		},
		{ 6,    "Dansk"				},
		{ 7,    "Norsk"				},
		{ 8,    "Svenska"			},
		{ 9,    "Suomi"				},
		{ 10,   "Bahasa Indonesia"	},
		{ 11,   "Japanese"			},
	 }
	
}

VARIABLE trans1_tb_display_contrast
{
	LABEL		[V5H6_LABEL_change];		// 
	HELP		[V5H6_LABEL_change_help];	// 
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER(1);
	HANDLING	READ & WRITE;
}

VARIABLE trans1_tb_display_form_flow
{
	LABEL		[V5H5_LABEL_change];		// 
	HELP		[V5H5_LABEL_change_help];	// 
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	1 ;
		{ 1,	"X.XXXX"		},
		{ 2,    "X.XXX"			},
		{ 3,    "X.XX"			},
	}
}

VARIABLE trans1_tb_iout_urv
{
	LABEL		[V1H0_LABEL_change];		// 
	HELP		[V1H0_LABEL_change_help];		// 
	CLASS		CONTAINED;
	TYPE		FLOAT;
	HANDLING IF (help_trans1_tb_code_page_loc != 4685)
	{
		READ;
	}
	ELSE
	{
		READ & WRITE;
	}

}

VARIABLE trans1_tb_iout_tau
{
	LABEL		[V1H4_LABEL_change];		// 
	HELP		[V1H4_LABEL_change_help];		// 
	CLASS		CONTAINED;
	TYPE		FLOAT;
	HANDLING	READ & WRITE;
    CONSTANT_UNIT  "s";
}

VARIABLE trans1_tb_iout_failsave
{
	LABEL		[V1H6_LABEL_change];	
	HELP		[V1H6_LABEL_change_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0 ;

		{ 0,	[enum_min] },
		{ 1,	[enum_max] },
		{ 2,	[enum_hold]},
		{ 3,	[enum_go]  },
	  }
}


VARIABLE trans1_tb_iout_act_value
{
	LABEL		[V1H8_LABEL_change];		// 
	HELP		[V1H8_LABEL_change_help];	// 
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT;
	HANDLING	READ;
}

VARIABLE trans1_tb_local_remote
{
	LABEL		[V6H2_LABEL_change];		// 
	HELP		[V6H2_LABEL_change_help];	// 
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;

		{ 0,	[yes]		},
		{ 1,	[no]		},

	}
}

VARIABLE help_trans1_tb_local_remote
{
	LABEL		[V6H2_LABEL_change];		// 
	HELP		[V6H2_LABEL_change_help];	// 
	CLASS		LOCAL;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;

		{ 0,	[std_local_remote_enum]	},//Change001

	}

	HANDLING READ;
}

VARIABLE trans1_tb_tot_1
{
	LABEL		[V0H1_LABEL_change];		// 
	HELP		[V0H1_LABEL_change_help];	// 
	CLASS		CONTAINED & DYNAMIC;
	TYPE		FLOAT;
	HANDLING	READ;
}

VARIABLE trans1_tb_cur_range
{
	LABEL		[V1H5_LABEL_change];		// 
	HELP		[V1H5_LABEL_change_help];	// 
	CLASS		CONTAINED;
//	TYPE		UNSIGNED_INTEGER (1)
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	3 ;

		{ 2,	"0-20mA"		 },
		{ 0,	"0-20mA (25mA)"	 },
		{ 3,	"4-20mA"		 },
		{ 1,	"4-20mA (25mA)"	 },
	}
	POST_EDIT_ACTIONS
	{
		meth_post_edit_trans1_tb_cur_range
	}

  }

METHOD meth_post_edit_trans1_tb_cur_range
{
	LABEL		"meth_post_edit_trans1_tb_cur_range";
	DEFINITION
	{
		int sim_current;

		sim_current = trans1_tb_iout_sim_current;
		switch (trans1_tb_cur_range)
		{
			case 0:
				if (!((sim_current == 0)||(sim_current == 1)||(sim_current == 4)||(sim_current == 6)||
					 (sim_current == 8))) 
				{
					trans1_tb_iout_sim_current = 1;
				}
				else
				{
					;
				}
				break;

			case 1:
				if (!((sim_current == 0) || (sim_current == 2) || (sim_current == 3) ||
					 (sim_current == 5) || (sim_current == 6) || (sim_current == 8))) 
			
				{
					trans1_tb_iout_sim_current = 2;
				}
				else
				{
					;
				}

				break;
			case 2:
				if (!((sim_current == 0) ||(sim_current == 1)||(sim_current == 4) || (sim_current == 6) ||
					  (sim_current == 7))) 
				{
					trans1_tb_iout_sim_current = 1;
				}
				else
				{
					;
				}

				break;
			case 3:
				if (!((sim_current == 0) || (sim_current == 2) || (sim_current == 3) ||
					 (sim_current == 5) || (sim_current == 6) || (sim_current == 7))) 
				{
					trans1_tb_iout_sim_current = 2;
				}
				else
				{
					;
				}
				break;
			default:
				
		}

	}
	
}

VARIABLE trans1_tb_iout_sim_current
{
	LABEL		[V1H7_LABEL_change];	
	HELP		[V1H7_LABEL_change_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0 ;

		SELECT (trans1_tb_cur_range)
		{
		
			CASE 2: // Bereich 0-20mA
				{ 0,	[off]		},
				{ 1,  "0 mA"		},
				{ 4,  "10 mA"	},
				{ 6,  "20 mA"	},
				{ 7,  "22 mA"	},

			CASE 0: // Bereich 0-20mA(25mA)
				{ 0,	[off]		},
				{ 1,  "0 mA"		},
				{ 4,  "10 mA"	},
				{ 6,  "20 mA"	},
				{ 8,  "25 mA"	},

			CASE 3: // Bereich 4-20mA
				{ 0,	[off]		},
				{ 2,  "2 mA"		},
				{ 3,  "4 mA"		},
				{ 5,  "12 mA"	},
				{ 6,  "20 mA"	},
				{ 7,  "22 mA"	},

			CASE 1: // Bereich4-20mA(25mA)
				{ 0,	[off]		},
				{ 2,  "2 mA"		},
				{ 3,  "4 mA"		},
				{ 5,  "12 mA"	},
				{ 6,  "20 mA"	},
				{ 8,  "25 mA"	},
	DEFAULT:	{ 0,	[off]		},

		}

	}
}

VARIABLE trans1_tb_msue_page
{
	LABEL		[V8H2_LABEL_change];		// 
	HELP		[V8H2_LABEL_change_help];	// 
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0 ;
		{ 0,	[off] },
		{ 1,	[on] },
		{ 2,	[enum_empty]},
		{ 3,	[enum_full] },
	}

	HANDLING	READ & WRITE;
	VALIDITY	IF (trans1_tb_epd_electrode == 1)

				{
					TRUE;
				}
				ELSE
				{
					FALSE;
				}
}


VARIABLE trans1_tb_tot_reset
{
	LABEL		[V5H1_LABEL_change];	
	HELP		[V5H1_LABEL_change_help];
	CLASS		CONTAINED;
	HANDLING	READ & WRITE;
	TYPE		ENUMERATED (1)
//	TYPE		UNSIGNED_INTEGER (1);

	{
		DEFAULT_VALUE	0 ;
		{ 0,	[off]},
		{ 1,	[on] },
	}
}


VARIABLE trans1_tb_system_options
{
	LABEL		[trans_tb_system_options];		// 
	HELP		[trans_tb_system_options_help];		// 
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER(1);
	HANDLING	READ;
}

VARIABLE trans1_tb_sens_soft_int
{
	LABEL		[trans_tb_system_options];		// 
	HELP		[trans_tb_system_options_help];		// 
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER(2);
	HANDLING	READ;
}

/*******************************************************************************/
/*****	MENU Bar  ********************************************************/
/*******************************************************************************/

MENU Menu_Main_Specialist
{
	LABEL		[main_menu];
	ITEMS
	{
		Menu_File,
		Menu_S_Device,
		Menu_S_View,
		Menu_S_Options,
		Menu_Help
	}
}

MENU Menu_Main_Maintenance
{
	LABEL		[main_menu];
	ITEMS
	{
		Menu_File,
		Menu_M_Device,
		Menu_M_View,
		Menu_M_Options,
		Menu_Help
	}
}

/*---------------------------------------------------------------------*/
/*    Menu: Device			           */
/*---------------------------------------------------------------------*/

MENU Menu_S_Device
{
	LABEL		[menu_Device];
	ITEMS
	{
		std_NodeAddress,
		SEPARATOR,
		std_LoadinDevice,										
		std_LoadinPC,
		SEPARATOR,
		OnlineDialog_simulation,
		SEPARATOR,
		OnlineDialog_reset,
		/*OnlineDialog_reset_func2, Change001*/
		/*OnlineDialog_checking, Change001*/
		SEPARATOR,
		OnlineDialog_local_remote,//Change001
		OnlineDialog_trans1_msue,
		OnlineDialog_phys_security_locking,
		/*OnlineDialog_trans1_tb_code_pageBi V1.5*/
	}
}

MENU Menu_M_Device
{
	LABEL		[menu_Device];
	ITEMS
	{
		std_LoadinDevice,										
		std_LoadinPC											
	}
}

METHOD std_NodeAddress
{
	LABEL		[menu_Device_NodeAddress];
	DEFINITION
	{
	}
}

METHOD std_LoadinDevice
{
	LABEL		[menu_Device_LoadinDevice];
	DEFINITION
	{
	}
}

METHOD std_LoadinPC
{
	LABEL		[menu_Device_LoadinPC];
	DEFINITION
	{
	}
}

/*******************************************************************************/
/*****	Online-Windows  **************************************************/
/*******************************************************************************/

MENU OnlineWindow_display
{
	LABEL		[menu_dialog_display];
	ITEMS
	{
		Page_display_trans1,
		Page_func1_out_display,
		Page_func2_out_display
	}
}

MENU Menu_S_alarm
{
	LABEL		[menu_dialog_alarm];
	ITEMS
	{
		OnlineWindow_S_alarm_func1,
//		OnlineWindow_S_alarm_func2,
		OnlineWindow_func2_S_alarm
	}
}

MENU Menu_M_alarm
{
	LABEL		[menu_dialog_alarm];
	ITEMS
	{
		OnlineWindow_M_alarm_func1,
//		OnlineWindow_M_alarm_func2,
		OnlineWindow_func2_M_alarm
	}
}

MENU Page_diagnosis_overview
{
	LABEL	[menu_dialog_overview];
	ITEMS
	{
		trans1.actual_mode,
		func1.actual_mode,
		func2.actual_mode,
		phys_actual_error_code
	}
}

MENU OnlineWindow_diagnosis
{
	LABEL		[menu_dialog_diagnosis];
	ITEMS
	{
		Page_diagnosis_overview,
		Page_diagnosis_general,
		Page_diagnosis_phys_block,
		Page_diagnosis_trans1,
		Page_diagnosis_func1,
		Page_diagnosis_func2	//Change001
	}
}

// ---- OnlineDialog Reset ----------------------------------------------------

//Change001 start
MENU OnlineDialog_reset
{
	LABEL		[reset_summe] ;
	ITEMS
	{
		Page_reset,
		Page_reset_func2_eh
	}
}

MENU Page_reset
{
	LABEL		[reset_summe_tb] ;
	ITEMS
	{
		trans1_tb_tot_reset,
		trans1_tb_tot_1
	}
}

MENU Page_reset_func2_eh
{
	LABEL		[reset_summe_tot];
	ITEMS
	{
		func2_out_total_value	(READ_ONLY), 
		func2_out_total_status	(READ_ONLY),
		func2_mode_tot			(READ_ONLY),
		func2_channel			(READ_ONLY),
		SEPARATOR,
		func2_reset_totalizer
	}
}
//Change001 end

/* Change001
MENU OnlineDialog_checking
{
	LABEL		"Selbsberwachung Ein/Aus" ;
	ITEMS
	{
		trans1_self_checking
	}
}
*/

MENU OnlineDialog_local_remote //Change001
{
	LABEL		[V6H2_LABEL_change];//Change001
	ITEMS
	{
		trans1_tb_local_remote
	}
}

/*Change001 start
MENU OnlineDialog_reset_totalizer
{
	LABEL		[reset_summe_tot] ;
	ITEMS
	{
		Page_reset_func2_eh
	}
}
Change001 end*/

// ---- OnlineDialog Simulation -----------------------------------------------

MENU OnlineDialog_simulation
{
	LABEL		[menu_dialog_simulation];
	ITEMS
	{
		Page_func1_s_simulation
	}
}

MENU OnlineDialog_phys_security_locking
{
	LABEL		[phys_security_locking];
	ITEMS
	{
		phys_security_locking
	}
}

MENU OnlineDialog_trans1_tb_code_page
{
	LABEL		[V7H2_LABEL_change];
	ITEMS
	{
		trans1_tb_code_page
	}
}

MENU OnlineDialog_trans1_msue
{
	LABEL		[V8H2_LABEL_change];
	ITEMS
	{
		Page_trans1_tb_msue_page,
		Page_trans1_tb_epd_responce_time,
	}


}

MENU Page_trans1_tb_msue_page
{
	LABEL		[V8H2_LABEL_change];
	ITEMS
	{
		trans1_tb_msue_page
	}
}

MENU Page_trans1_tb_epd_responce_time
{
	LABEL		[V8H3_LABEL_change];
	ITEMS
	{
		trans1_tb_epd_responce_time
	}
}



/*******************************************************************************/
/*****	Table: Specialist  **************************************************/
/*******************************************************************************/

MENU Table_Main_Specialist
{
	LABEL	DEVICE_TITLE ;
	ITEMS
	{
		Tab_s_EH_Std_Matrix,
		Tab_s_electro_pa_profile
	}
}

MENU Tab_s_electro_pa_profile
{
	LABEL	[electro_pa_profile] ;
	ITEMS
	{
		Tab_s_ident,
		/*tab_s_operate_parameter,B V1.5*/
		Tab_s_input,
		Tab_s_output,    
		/*Tab_s_interface,Bi V1.5 */
		Tab_s_certificates,
	}
}

MENU Tab_s_input
{
	LABEL		[menu_input];
	ITEMS
	{
		trans1_tb_unit_volume			(READ_ONLY),
		trans1_tb_gal_bar				(READ_ONLY),
		trans1_tb_unit_diameter			(READ_ONLY),
		Tab_s_input_trans1
	}
}

MENU Tab_s_output
{
	LABEL		[menu_output];
	ITEMS
	{
/*		tab_current_out Bi V1.5*/
		Tab_s_func1,
		Tab_s_func2		
	}
}

MENU Tab_s_EH_Std_Matrix
{
	LABEL	[table_eh_std_matrix];
	ITEMS
	{
		tab_s_measured_value,
		tab_s_current_output,
		tab_s_measured_display,
		tab_s_communication,
		tab_s_system_parameter,
		tab_s_prozess_parameter,
		tab_s_sensor_date,
		tab_s_startup
	}
}

MENU tab_s_measured_value
{
	LABEL	[tab_s_measured_value];
	ITEMS
	{
		help_trans1_flowrate,
		help_trans1_tb_tot_1,
#ifdef TRANS1_PRIVATE_UNITS
		trans1_flowrate_private_unit,
#else
		matrix_par.trans1_flowrate_unit,
#endif
		trans1_tb_unit_volume,
		trans1_tb_gal_bar,
		trans1_tb_unit_diameter
	}
}

MENU tab_s_current_output
{
	LABEL	[tab_s_current_output];
	ITEMS
	{
		trans1_tb_iout_urv,
		trans1_tb_iout_tau,
		trans1_tb_cur_range,
		trans1_tb_iout_failsave,
		trans1_tb_iout_sim_current,
		trans1_tb_iout_act_value
	}
}
/* Bi V1.5 start
MENU tab_current_out
{
	LABEL	[tab_s_current_output];
	ITEMS
	{
		trans1_tb_iout_urv			(READ_ONLY),
		trans1_tb_iout_tau			(READ_ONLY),
		trans1_tb_cur_range			(READ_ONLY),
		trans1_tb_iout_failsave		(READ_ONLY),
		trans1_tb_iout_sim_current	(READ_ONLY),
		trans1_tb_iout_act_value	(READ_ONLY)
	}
}
Bi V1.5 end*/
MENU tab_s_measured_display
{
	LABEL	[tab_s_measured_display];
	ITEMS
	{
		help_tb_tot_reset,//Change001
		trans1_tb_assign_disp_line1,
		trans1_tb_assign_disp_line2,
		trans1_tb_display_damping,
		trans1_tb_display_form_flow,
		trans1_tb_display_contrast,
		trans1_tb_assign_language
		
	}
}

MENU tab_s_communication
{
	LABEL	[tab_s_communication];
	ITEMS
	{
		phys_bus_address,
		help_trans1_tb_local_remote
	}
}

MENU tab_s_system_parameter
{
	LABEL	[tab_s_system_parameter];
	ITEMS
	{
		trans1_tb_pzr,
		help_trans1_tb_code_page_loc,
		matrix_par.trans1_self_checking,
		phys_actual_error_code,
		trans1_tb_sens_sw_ver,
		matrix_par.phys_software_rev,
		matrix_par.phys_hardware_rev
	}
}
/* Bi V1.5 start
MENU tab_s_operate_parameter
{
	LABEL	[menu_control_parameter];//Change001
	ITEMS
	{
		tab_s_system_parameter1,
		tab_s_prozess_parameter1,
		tab_s_sensor_date1
	}
}

MENU tab_s_system_parameter1
{
	LABEL	[tab_s_system_parameter_change];
	ITEMS
	{
		trans1_tb_pzr					(READ_ONLY),
		help_trans1_tb_code_page		(READ_ONLY),
		matrix_par.trans1_self_checking	(READ_ONLY),
		help_phys_actual_error_code		(READ_ONLY),
		trans1_tb_sens_sw_ver			(READ_ONLY),
		matrix_par.phys_software_rev	(READ_ONLY),
		matrix_par.phys_hardware_rev	(READ_ONLY)
	}
}

MENU tab_s_prozess_parameter1
{
	LABEL	[tab_s_prozess_parameter_change];
	ITEMS
	{
		trans1_low_flow_cutoff			(READ_ONLY),
		matrix_par.trans1_filter_type	(READ_ONLY),
		trans1_tb_msue_page				(READ_ONLY),
		matrix_par.trans1_device_mode	(READ_ONLY),
		matrix_par.trans1_flow_direction(READ_ONLY),
		trans1_tb_amp_mode				(READ_ONLY),
		trans1_tb_delay					(READ_ONLY)
	}
}
Bi V1.5 end*/
MENU tab_s_prozess_parameter
{
	LABEL	[tab_s_prozess_parameter];
	ITEMS
	{
		trans1_low_flow_cutoff,
		matrix_par.trans1_filter_type
		trans1_tb_msue_page (READ_ONLY),
		trans1_tb_epd_responce_time (READ_ONLY),
		matrix_par.trans1_device_mode,
		matrix_par.trans1_flow_direction,
		trans1_tb_amp_mode,
		trans1_tb_delay
	}
}
MENU tab_s_sensor_date
{
	LABEL	[tab_s_sensor_date];
	ITEMS
	{
		matrix_par.trans1_calibration_factor,
		trans1_tb_calib_fact_neg,
		matrix_par.trans1_zero_point
		trans1_normal_size,
		trans1_tb_max_sample_rate,
		trans1_sample_rate,
		matrix_par.phys_serial_num,
		trans1_tb_epd_electrode
	}
}

MENU tab_s_sensor_date1
{
	LABEL	[tab_s_sensor_date_change];
	ITEMS
	{
		matrix_par.trans1_calibration_factor(READ_ONLY),
		trans1_tb_calib_fact_neg			(READ_ONLY),
		matrix_par.trans1_zero_point		(READ_ONLY),
		trans1_normal_size					(READ_ONLY),
		trans1_tb_max_sample_rate			(READ_ONLY),
		trans1_sample_rate					(READ_ONLY),
		matrix_par.phys_serial_num			(READ_ONLY),
		trans1_tb_epd_electrode				(READ_ONLY)
	}
}

MENU tab_s_startup
{
	LABEL	[tab_s_startup];
	ITEMS
	{
		matrix_par.trans1_tag_desc
	}
}

/*******************************************************************************/
/*****	Table: Maintenance  **********************************************/
/*******************************************************************************/

MENU Table_Main_Maintenance
{
	LABEL	DEVICE_TITLE ;
	ITEMS
	{
		Tab_s_EH_Std_Matrix,
		Tab_m_electro_pa_profile,
	
	}
}
MENU Tab_m_electro_pa_profile
{
	LABEL	[electro_pa_profile] ;
	ITEMS
	{
		Tab_m_ident,
		/*tab_s_operate_parameter,B V1.5*/
		Tab_m_input,
		Tab_m_output,    
		/*Tab_s_interface,Bi V1.5 */
		Tab_s_certificates,
	}
}

MENU Tab_m_input
{
	LABEL		[menu_input];
	ITEMS
	{
		trans1_tb_unit_volume			(READ_ONLY),
		trans1_tb_gal_bar				(READ_ONLY),
		trans1_tb_unit_diameter			(READ_ONLY),
		Tab_m_input_trans1
	}
}

MENU Tab_m_output
{
	LABEL		[menu_output];
	ITEMS
	{
	/*	tab_current_out,Bi V1.5*/
		Tab_m_func1,
		Tab_m_func2		
	}
}

/*******************************************************************************/
/*****	Methods		*****************************************/
/*******************************************************************************/

METHOD sie_set
{
	LABEL		[transfer];
	HELP		[transfer_help];
	DEFINITION
	{
	}
}

/*******************************************************************************/
/*****	Commands  *******************************************************/
/*******************************************************************************/
VARIABLE local_abort
{
	LABEL	"ABORT";
	TYPE INTEGER
	{
		DEFAULT_VALUE	0;
	}
}

METHOD meth_abort
{
	DEFINITION
	{

		local_abort = 1; //Abbruch
		ACKNOWLEDGE([acknowledge_process_aborted]);
	}
}

METHOD pre_write_varibles
{
	LABEL "pre_write_varibles" ;
	DEFINITION
	{
		int ret;

		local_abort = 0;
		
		ReadCommand(read_trans1_tb_amp_mode) ;
		
		add_abort_method (meth_abort);
		
		// Schreibschutz abfragen
		
		ret = ReadCommand (read_trans1_tb_local_remote);
		if (ret >= ID_FC_ERROR) process_abort();
		
				
		if (trans1_tb_local_remote != 1) 
		{
			
			local_abort = 1;
			PUT_MESSAGE ([mess_loc_operation]+[acknowledge_process_aborted]);
		}
		
		if ((help_trans1_tb_code_page_loc != 33) && (help_trans1_tb_code_page_loc != 4685) && (help_trans1_tb_code_page_loc != 35))
		{
			
			local_abort = 1;
			ACKNOWLEDGE ([ack_no_access]);
		}	
		
	}
}

MENU upload_variables
{
	LABEL		[menu_load_to_device];
	PRE_WRITE_ACTIONS
	{
		GetNumericSoftwareRevision,
		pre_write_varibles
	}
	ITEMS
	{
		IF (local_abort == 0)
		{
		PHYS_LOAD_TO_DEVICE

		// unit-Parameter zuerst schreiben
		trans1_flowrate_unit,
		trans1_tb_unit_diameter,
		trans1_tb_unit_volume,
	IF ((trans1_tb_unit_volume == 40) || 
		(trans1_tb_unit_volume == 46) ||
		(trans1_tb_unit_volume == 244)||
		(trans1_flowrate_unit == 16)  ||
		(trans1_flowrate_unit == 136) ||
		(trans1_flowrate_unit == 235) ||
		(trans1_flowrate_unit == 23)
		) 
		{
			trans1_tb_gal_bar,
		}

	/* TRANDSDUCER BLOCK, STANDARD PARAMETER	*/
	/* TRANDSDUCER BLOCK, ADDITIONAL PARAMETER	*/
//		trans1_flowrate_private_unit,
		trans1_device_mode,
		
		trans1_low_flow_cutoff,
		trans1_filter_type,
		trans1_flow_direction,
		
		
		
		trans1_tag_desc,
		trans1_self_checking,

	/* TRANSDUCER BLOCK, DEVICE SPECIFIC PARAMETER */
/* geht nicht mit 2.06*/
		
		trans1_tb_display_damping,
		/*IF (trans1_tb_epd_electrode == 1)
		{
		trans1_tb_msue_page,
		}Bi V1.5*/
		trans1_tb_pzr,
		//trans1_tb_amp_mode,
		IF (trans1_tb_amp_mode == 0)
		{
			trans1_tb_delay,
		}
		IF (help_trans1_tb_code_page_loc == 4685) //Werkseinstellungen nur mit Servicecode schreibbar Bi V1.5
		{
			trans1_calibration_factor,
			trans1_tb_calib_fact_neg,
			trans1_tb_max_sample_rate,
			trans1_sample_rate,
			trans1_tb_iout_urv,
			trans1_tb_epd_electrode,
			trans1_zero_point,
			trans1_normal_size,
		}
			
		trans1_tb_assign_disp_line1,
		trans1_tb_assign_disp_line2,
		trans1_tb_assign_language,
		trans1_tb_display_contrast,
		trans1_tb_display_form_flow,
		
		trans1_tb_iout_tau,
		trans1_tb_iout_failsave,
		trans1_tb_iout_sim_current,
		//trans1_tb_local_remote,
		//trans1_tb_code_page,
		trans1_tb_cur_range,
		//trans1_tb_tot_reset,Change001
/* geht nicht mit 2.06*/

		FUNC1_LOAD_TO_DEVICE 

	/* FUNCTION BLOCK 2, STANDARD PARAMETER	*/
	/* FUNCTION BLOCK 2, ADDITIONAL PARAMETER	*/
		func2_tot_units,
		func2_mode_tot,
		func2_fail_tot,
		func2_polar_tot,
		func2_alarm_hys,
		func2_hi_hi_lim,
		func2_hi_lim
		}
	}
}

METHOD pre_read_variables
{
	LABEL "pre_read_varibles" ;
	DEFINITION
	{
		int ret;

		add_abort_method (meth_abort);
		
		ret = ReadCommand(read_trans1_tb_unit_volume) ;
		if (ret >= ID_FC_ERROR) process_abort();

		ret = ReadCommand(read_trans1_flowrate_unit) ;
		if (ret >= ID_FC_ERROR) process_abort();

		ret = ReadCommand(read_trans1_tb_amp_mode) ;
		if (ret >= ID_FC_ERROR) process_abort();

		
	}
}
MENU download_variables
{
	LABEL		[menu_load_to_PC];

	PRE_READ_ACTIONS
	{
		GetNumericSoftwareRevision,
		pre_read_variables
	}

	ITEMS
	{
		PHYS_LOAD_TO_PC
		phys_bus_address,
		phys_actual_error_code,
		// unit-Parameter zuerst lesen
		//trans1_flowrate_unit,		pre_read_variables
		//trans1_tb_unit_volume,	pre_read_variables
		trans1_tb_unit_diameter,
		IF ((trans1_tb_unit_volume == 40) || 
			(trans1_tb_unit_volume == 46) ||
			(trans1_tb_unit_volume == 244)||
			(trans1_flowrate_unit == 16)  ||
			(trans1_flowrate_unit == 136) ||
			(trans1_flowrate_unit == 235) ||
			(trans1_flowrate_unit == 23)	) 
		{
			trans1_tb_gal_bar,
		}
		trans1_low_flow_cutoff,
		trans1_filter_type,
		trans1_flow_direction,
		trans1_zero_point,
		trans1_sample_rate,
		trans1_tag_desc,
		trans1_self_checking,
		trans1_calibration_factor,
	/* TRANDSDUCER BLOCK, STANDARD PARAMETER	*/
	/* TRANDSDUCER BLOCK, ADDITIONAL PARAMETER	*/
		trans1_device_mode,
		trans1_normal_size,
	/* TRANDSDUCER BLOCK, ADDITIONAL PARAMETER (ELECTRO MAGNETIC FLOW) */
//		trans1_flowrate,
		trans1_st_rev,
	/* TRANSDUCER BLOCK, DEVICE SPECIFIC PARAMETER */
		trans1_tb_pzr,
		//trans1_tb_amp_mode,		pre_read_variables
		IF (trans1_tb_amp_mode == 0)
		{
			trans1_tb_delay,
		}
//		trans1_tb_tot_1,
		trans1_tb_display_damping,
		trans1_tb_epd_electrode,
		trans1_tb_sens_sw_ver,
		IF (trans1_tb_epd_electrode == 1)
		{
		trans1_tb_msue_page,
		}
		trans1_tb_calib_fact_neg,
		trans1_tb_max_sample_rate,
		trans1_tb_assign_disp_line1,
		trans1_tb_assign_disp_line2,
		trans1_tb_assign_language,
		trans1_tb_display_contrast,
		trans1_tb_display_form_flow,
		trans1_tb_iout_urv,
		trans1_tb_iout_tau,
		trans1_tb_iout_act_value,
		trans1_tb_iout_failsave,
		trans1_tb_iout_sim_current,
		//trans1_tb_local_remote,
		//trans1_tb_code_page,
		trans1_tb_cur_range,
		//trans1_tb_tot_reset,Change001

	FUNC1_LOAD_TO_PC,
	/* FUNCTION BLOCK 2, STANDARD PARAMETER		*/
		func2_st_rev,
	/* FUNCTION BLOCK 2, ADDITIONAL PARAMETER	*/
		func2_tot_units,
		func2_mode_tot,
		func2_fail_tot,
		func2_polar_tot,
		func2_alarm_hys,
		func2_hi_hi_lim,
		func2_hi_lim
	}
}

/***************************************************************************************/
/*   Commands								*/
/**************************************************************************************/

COMMAND read_trans1_tb_system_config
{
	BLOCK transducer_block_1;
	INDEX 35;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tb_system_config
		}
	}
}


COMMAND read_trans1_tb_totalizer_overflows
{
	BLOCK transducer_block_1;
	INDEX 36;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tb_totalizer_overflows
		}
	}
}


COMMAND read_trans1_tb_unit_diameter
{
	BLOCK transducer_block_1;
	INDEX 38;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tb_unit_diameter
		}
	}
}

COMMAND write_trans1_tb_unit_diameter
{
	BLOCK transducer_block_1;
	INDEX 38;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tb_unit_diameter
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tb_unit_volume
{
	BLOCK transducer_block_1;
	INDEX 39;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tb_unit_volume
		}
	}
}

COMMAND write_trans1_tb_unit_volume
{
	BLOCK transducer_block_1;
	INDEX 39;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tb_unit_volume
		}
		REPLY
		{
		}
	}
}


COMMAND read_trans1_tb_pzr
{
	BLOCK transducer_block_1;
	INDEX 40;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tb_pzr
		}
	}
}

COMMAND write_trans1_tb_pzr
{
	BLOCK transducer_block_1;
	INDEX 40;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tb_pzr
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tb_epd_responce_time
{
	BLOCK transducer_block_1;
	INDEX 41;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tb_epd_responce_time
		}
	}
}

COMMAND write_trans1_tb_epd_responce_time
{
	BLOCK transducer_block_1;
	INDEX 41;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tb_epd_responce_time
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tb_amp_mode
{
	BLOCK transducer_block_1;
	INDEX 46;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tb_amp_mode
		}
	}
}

COMMAND write_trans1_tb_amp_mode
{
	BLOCK transducer_block_1;
	INDEX 46;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tb_amp_mode
		}
		REPLY
		{
		}
	}
}


COMMAND read_trans1_tb_calib_fact_neg
{
	BLOCK transducer_block_1;
	INDEX 48;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tb_calib_fact_neg
		}
	}
}

COMMAND write_trans1_tb_calib_fact_neg
{
	BLOCK transducer_block_1;
	INDEX 48;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tb_calib_fact_neg
		}
		REPLY
		{
		}
	}
}


COMMAND read_trans1_tb_max_sample_rate
{
	BLOCK transducer_block_1;
	INDEX 49;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tb_max_sample_rate
		}
	}
}

COMMAND write_trans1_tb_max_sample_rate
{
	BLOCK transducer_block_1;
	INDEX 49;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tb_max_sample_rate
		}
		REPLY
		{
		}
	}
}


COMMAND read_trans1_tb_sens_sw_ver
{
	BLOCK transducer_block_1;
	INDEX 50;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tb_sens_sw_ver
		}
	}
}


COMMAND read_trans1_tb_assign_disp_line1
{
	BLOCK transducer_block_1;
	INDEX 51;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tb_assign_disp_line1
		}
	}
}

COMMAND write_trans1_tb_assign_disp_line1
{
	BLOCK transducer_block_1;
	INDEX 51;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tb_assign_disp_line1
		}
		REPLY
		{
		}
	}
}


COMMAND read_trans1_tb_assign_disp_line2
{
	BLOCK transducer_block_1;
	INDEX 52;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tb_assign_disp_line2
		}
	}
}

COMMAND write_trans1_tb_assign_disp_line2
{
	BLOCK transducer_block_1;
	INDEX 52;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tb_assign_disp_line2
		}
		REPLY
		{
		}
	}
}


COMMAND read_trans1_tb_assign_language
{
	BLOCK transducer_block_1;
	INDEX 53;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tb_assign_language
		}
	}
}

COMMAND write_trans1_tb_assign_language
{
	BLOCK transducer_block_1;
	INDEX 53;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tb_assign_language
		}
		REPLY
		{
		}
	}
}


COMMAND read_trans1_tb_display_contrast
{
	BLOCK transducer_block_1;
	INDEX 54;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tb_display_contrast
		}
	}
}

COMMAND write_trans1_tb_display_contrast
{
	BLOCK transducer_block_1;
	INDEX 54;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tb_display_contrast
		}
		REPLY
		{
		}
	}
}


COMMAND read_trans1_tb_display_form_flow
{
	BLOCK transducer_block_1;
	INDEX 56;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tb_display_form_flow
		}
	}
}

COMMAND write_trans1_tb_display_form_flow
{
	BLOCK transducer_block_1;
	INDEX 56;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tb_display_form_flow
		}
		REPLY
		{
		}
	}
}


COMMAND read_trans1_tb_iout_urv
{
	BLOCK transducer_block_1;
	INDEX 58;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tb_iout_urv
		}
	}
}

COMMAND write_trans1_tb_iout_urv
{
	BLOCK transducer_block_1;
	INDEX 58;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tb_iout_urv
		}
		REPLY
		{
		}
	}
}


COMMAND read_trans1_tb_iout_tau
{
	BLOCK transducer_block_1;
	INDEX 59;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tb_iout_tau
		}
	}
}

COMMAND write_trans1_tb_iout_tau
{
	BLOCK transducer_block_1;
	INDEX 59;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tb_iout_tau
		}
		REPLY
		{
		}
	}
}


COMMAND read_trans1_tb_iout_failsave
{
	BLOCK transducer_block_1;
	INDEX 60;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tb_iout_failsave
		}
	}
}

COMMAND write_trans1_tb_iout_failsave
{
	BLOCK transducer_block_1;
	INDEX 60;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tb_iout_failsave
		}
		REPLY
		{
		}
	}
}


COMMAND read_trans1_tb_iout_sim_current
{
	BLOCK transducer_block_1;
	INDEX 61;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tb_iout_sim_current
		}
	}
}

COMMAND write_trans1_tb_iout_sim_current
{
	BLOCK transducer_block_1;
	INDEX 61;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tb_iout_sim_current
		}
		REPLY
		{
		}
	}
}


COMMAND read_trans1_tb_iout_act_value
{
	BLOCK transducer_block_1;
	INDEX 62;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tb_iout_act_value
		}
	}
}


COMMAND read_trans1_tb_local_remote
{
	BLOCK transducer_block_1;
	INDEX 63;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tb_local_remote
		}
	}
}

COMMAND write_trans1_tb_local_remote
{
	BLOCK transducer_block_1;
	INDEX 63;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tb_local_remote
		}
		REPLY
		{
		}
	}
}


COMMAND read_trans1_tb_code_page
{
	BLOCK transducer_block_1;
	INDEX 64;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tb_code_page
		}
	}
}

COMMAND write_trans1_tb_code_page
{
	BLOCK transducer_block_1;
	INDEX 64;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tb_code_page
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tb_tot_1
{
	BLOCK transducer_block_1;
	INDEX 65;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tb_tot_1
		}
	}
}


COMMAND read_trans1_tb_cur_range
{
	BLOCK transducer_block_1;
	INDEX 66;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tb_cur_range
		}
	}
}

COMMAND write_trans1_tb_cur_range
{
	BLOCK transducer_block_1;
	INDEX 66;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tb_cur_range
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tb_msue_page
{
	BLOCK transducer_block_1;
	INDEX 67;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tb_msue_page
		}
	}
}

COMMAND write_trans1_tb_msue_page
{
	BLOCK transducer_block_1;
	INDEX 67;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tb_msue_page
		}
		REPLY
		{
		}
	}
}


COMMAND read_trans1_tb_tot_reset
{
	BLOCK transducer_block_1;
	INDEX 68;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tb_tot_reset
		}
	}
}

COMMAND write_trans1_tb_tot_reset
{
	BLOCK transducer_block_1;
	INDEX 68;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tb_tot_reset
		}
		REPLY
		{
		}
	}
}


COMMAND read_trans1_tb_system_options
{
	BLOCK transducer_block_1;
	INDEX 69;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tb_system_options
		}
	}
}


COMMAND read_trans1_tb_sens_soft_int
{
	BLOCK transducer_block_1;
	INDEX 70;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tb_sens_soft_int
		}
	}
}


//#ifdef ___DISABLED_PARAMTERS

COMMAND read_trans1_tb_gal_bar
{
	BLOCK transducer_block_1;
	INDEX 37;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tb_gal_bar
		}
	}
}

COMMAND write_trans1_tb_gal_bar
{
	BLOCK transducer_block_1;
	INDEX 37;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tb_gal_bar
		}
		REPLY
		{
		}
	}
}

VARIABLE trans1_tb_gal_bar
{
	LABEL		[trans_tb_gal_bar];		// 
	HELP		[trans_tb_gal_bar_help];		// 
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	1 ;

		{ 0,	"US: 31,0 gal/bbl"	},
		{ 1,	"US: 31,5 gal/bbl"	},
		{ 2,	"US: 42,0 gal/bbl"	},
		{ 3,	"US: 55,0 gal/bbl"	},
		{ 4,	"Imp: 36,0 gal/bbl" },
		{ 5,	"Imp: 36,0 gal/bbl" },
	}
	VALIDITY	IF ((trans1_tb_unit_volume == 40) || 
					(trans1_tb_unit_volume == 46) ||
					(trans1_tb_unit_volume == 244)||
					(trans1_flowrate_unit == 16)  ||
					(trans1_flowrate_unit == 136) ||
					(trans1_flowrate_unit == 235) ||
					(trans1_flowrate_unit == 23)
					) 
				{
					TRUE;
				}
				ELSE
				{
					FALSE;
				}

	HANDLING	READ & WRITE;
}


COMMAND read_trans1_tb_coil_slope_page
{
	BLOCK transducer_block_1;
	INDEX 71;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tb_coil_slope_page
		}
	}
}


COMMAND write_trans1_tb_coil_slope_page
{
	BLOCK transducer_block_1;
	INDEX 71;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tb_coil_slope_page
		}
		REPLY
		{
		}
	}
}

COMMAND read_phys_actual_error_code
{
	BLOCK physical_block;
	INDEX 38;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_actual_error_code
		}
	}
}

COMMAND read_phys_bus_address
{
	BLOCK physical_block;
	INDEX 43;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			phys_bus_address
		}
	}
}


VARIABLE trans1_tb_coil_slope_page
{
	LABEL		[trans_tb_coil_slope_page];		// 
	HELP		[trans_tb_coil_slope_page_help];		// 
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER(2);
	HANDLING	READ & WRITE;
}


COMMAND read_trans1_tb_epd_electrode
{
	BLOCK transducer_block_1;
	INDEX 43;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tb_epd_electrode
		}
	}
}

COMMAND write_trans1_tb_epd_electrode
{
	BLOCK transducer_block_1;
	INDEX 43;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tb_epd_electrode
		}
		REPLY
		{
		}
	}
}

VARIABLE trans1_tb_epd_electrode
{
	LABEL		[V9H7_LABEL_change];		// 
	HELP		[V9H7_LABEL_change_help];		// 
	CLASS		CONTAINED;
//	TYPE		UNSIGNED_INTEGER(1);
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;
		{ 0,	[no]},
		{ 1,	[yes]	},
	}
	HANDLING IF ( help_trans1_tb_code_page_loc!= 4685)
	{
		READ;
	}
	ELSE
	{
		READ & WRITE;
	}

}
// Bi V1.5
VARIABLE trans1_calibration_factor
{

	HANDLING IF ( help_trans1_tb_code_page_loc!= 4685)
	{
		READ;
	}
	ELSE
	{
		READ & WRITE;
	}

}

VARIABLE trans1_zero_point
{

	HANDLING IF ( help_trans1_tb_code_page_loc!= 4685)
	{
		READ;
	}
	ELSE
	{
		READ & WRITE;
	}

}


COMMAND read_trans1_tb_function_ecc
{
	BLOCK transducer_block_1;
	INDEX 42;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tb_function_ecc
		}
	}
}

COMMAND write_trans1_tb_function_ecc
{
	BLOCK transducer_block_1;
	INDEX 42;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tb_function_ecc
		}
		REPLY
		{
		}
	}
}

VARIABLE trans1_tb_function_ecc
{
	LABEL		[trans_tb_function_ecc];		// 
	HELP		[trans_tb_function_ecc_help];	// 
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER(1);
	HANDLING	READ & WRITE;
}


COMMAND read_trans1_tb_recovery_time_ecc
{
	BLOCK transducer_block_1;
	INDEX 44;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tb_recovery_time_ecc
		}
	}
}

COMMAND write_trans1_tb_recovery_time_ecc
{
	BLOCK transducer_block_1;
	INDEX 44;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tb_recovery_time_ecc
		}
		REPLY
		{
		}
	}
}

VARIABLE trans1_tb_recovery_time_ecc
{
	LABEL		[trans_tb_recovery_time_ecc];		// 
	HELP		[trans_tb_recovery_time_ecc_help];	// 
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER(2);
	HANDLING	READ & WRITE;
}



COMMAND read_trans1_tb_polarity_ecc
{
	BLOCK transducer_block_1;
	INDEX 45;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tb_polarity_ecc
		}
	}
}

COMMAND write_trans1_tb_polarity_ecc
{
	BLOCK transducer_block_1;
	INDEX 45;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tb_polarity_ecc
		}
		REPLY
		{
		}
	}
}

VARIABLE trans1_tb_polarity_ecc
{
	LABEL		[trans_tb_polarity_ecc];		// 
	HELP		[trans_tb_polarity_ecc_help];	// 
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER(1);
	HANDLING	READ & WRITE;
}

COMMAND read_trans1_tb_delay
{
	BLOCK transducer_block_1;
	INDEX 47;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tb_delay
		}
	}
}

COMMAND write_trans1_tb_delay
{
	BLOCK transducer_block_1;
	INDEX 47;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tb_delay
		}
		REPLY
		{
		}
	}
}

COMMAND read_trans1_tb_display_damping
{
	BLOCK transducer_block_1;
	INDEX 55;
	OPERATION READ;
	TRANSACTION
	{
		REQUEST
		{
		}
		REPLY
		{
			trans1_tb_display_damping
		}
	}
}

COMMAND write_trans1_tb_display_damping
{
	BLOCK transducer_block_1;
	INDEX 55;
	OPERATION WRITE;
	TRANSACTION
	{
		REQUEST
		{
			trans1_tb_display_damping
		}
		REPLY
		{
		}
	}
}

VARIABLE trans1_tb_delay
{
	LABEL		[V8H9_LABEL_change];		
	HELP		[V8H9_LABEL_change_help];		 
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER(2);
	HANDLING	READ & WRITE;
	VALIDITY	IF (trans1_tb_amp_mode == 0)
				{
					TRUE;
				}
				ELSE
				{
					FALSE;
				}
}

VARIABLE trans1_tb_display_damping
{
	LABEL		[V5H4_LABEL_change];		// 
	HELP		[V5H4_LABEL_change_help];	// 
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER(1);
	HANDLING	READ & WRITE;
    CONSTANT_UNIT  "s";
}

VARIABLE phys_bus_address
{
	LABEL		[V6H1_LABEL_change];
	HELP		[V6H1_LABEL_change_help];
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER
	{
		DEFAULT_VALUE	0;
	}

	HANDLING	READ;
}

VARIABLE trans1_device_mode
{
	LABEL		[V8H4_LABEL];
	HELP		[V8H4_LABEL_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (1)
	{
		{	0,  [uni_directional]	},
		{	1,  [bi_directional]	}
	}
	HANDLING	READ & WRITE;
}

VARIABLE trans1_normal_size
{
	LABEL		[V9H3_LABEL_change];
	HELP		[V9H3_LABEL_change_help];
	CLASS		CONTAINED;
	TYPE		FLOAT;
	CONSTANT_UNIT	IF (trans1_tb_unit_diameter == 47)
					{
						[in];
					}
					ELSE
					{
						[mm];
					}

	HANDLING IF (help_trans1_tb_code_page_loc != 4685)
	{
		READ;
	}
	ELSE
	{
		READ & WRITE;
	}

}

VARIABLE trans1_low_flow_cutoff
{
	LABEL		[V8H0_LABEL_change];
	HELP		[V8H0_LABEL_change_help];
	CLASS		CONTAINED;
	TYPE		FLOAT
	{
		DEFAULT_VALUE	0.0;
	}
	HANDLING	READ & WRITE;
}

UNIT TB_trans1_tb_unit_volume
{
	trans1_tb_unit_volume:

        trans1_tb_tot_1
}


UNIT TB_trans1_flowrate_private_unit
{
	//trans1_flowrate_private_unit:
	trans1_flowrate_unit:

        trans1_tb_iout_urv,
}

UNIT TB_trans1_tb_unit_diameter
{
	trans1_tb_unit_diameter:

        trans1_normal_size
}


VARIABLE phys_hardware_rev
{
	LABEL		[phys_hardware_revision];
	HELP		[phys_hardware_revision_help];
	CLASS		CONTAINED;
	TYPE		ASCII (16)
	{
		DEFAULT_VALUE	"1";
	}
	HANDLING	READ;
}

VARIABLE phys_software_rev
{
	LABEL		[phys_software_revision];
	HELP		[phys_software_revision_help];
	CLASS		CONTAINED;
	TYPE		ASCII (16)
	{
		DEFAULT_VALUE	"1";
	}
	HANDLING	READ;
}

VARIABLE phys_serial_num
{
	LABEL		[phys_device_ser_num];
	HELP		[phys_device_ser_num_help];
	CLASS		CONTAINED;
	TYPE		ASCII (16);
	HANDLING	READ;
}

VARIABLE trans1_tb_code_page
{
	LABEL		[V7H2_LABEL_change];		// 
	HELP		[V7H2_LABEL_change_help];	// 
	CLASS		CONTAINED;
	TYPE		UNSIGNED_INTEGER(2);
	HANDLING	READ & WRITE;
	
}

VARIABLE help_trans1_tb_code_page
{
	LABEL		[V7H2_LABEL_change];		// 
	HELP		[V7H2_LABEL_change_help];	// 
	CLASS		LOCAL;
	TYPE		ENUMERATED (1)
	{
		DEFAULT_VALUE	0;

		{ 0,	[std_code_enum]},	

	}
	HANDLING READ;
}
VARIABLE help_trans1_tb_code_page_loc
{
	LABEL		[V7H2_LABEL_change];		// 
	HELP		[V7H2_LABEL_change_help];	// 
	CLASS		LOCAL;
	TYPE		UNSIGNED_INTEGER(2)
	{
		DEFAULT_VALUE	0;
	}
	HANDLING READ&WRITE;
}


COLLECTION OF VARIABLE matrix_par
{

    MEMBERS
    {
		trans1_tag_desc, trans1_tag_desc,						[VAH0_LABEL_change];
 		phys_serial_num,phys_serial_num,						[V9H6_LABEL_change];
		phys_software_rev,phys_software_rev,					[V7H7_LABEL_change];
 		phys_hardware_rev,phys_hardware_rev,					[V7H8_LABEL_change];
		trans1_device_mode,trans1_device_mode,					[V8H4_LABEL_change];
//		func1_pv_ftime,func1_pv_ftime,							[V1H4_LABEL_change];
		trans1_flowrate_unit,trans1_flowrate_unit,				[V0H2_LABEL_change];
		trans1_self_checking,trans1_self_checking,				[V7H3_LABEL_change];
		trans1_calibration_factor,trans1_calibration_factor,	[V9H0_LABEL_change];
		trans1_zero_point,trans1_zero_point,					[V9H2_LABEL_change];
		trans1_flow_direction,trans1_flow_direction,			[V8H5_LABEL_change];
		trans1_filter_type,trans1_filter_type,					[V8H1_LABEL_change];
	}
}
MENU Page_display_trans1
{
	LABEL		[menu_dialog_display_measure];
	ITEMS
	{
		BarVal_trans1_pv_display,
#ifdef TRANS1_PRIVATE_UNITS
			,trans1_flowrate_private_unit(HIDDEN)
#endif
		BarVal_trans1_tb_tot_1
	}
}

MENU BarVal_trans1_tb_tot_1
{
	LABEL		[V0H1_LABEL_change];
	ITEMS
	{
		trans1_tb_tot_1
	}
}

MENU BarVal_trans1_pv_display
{
	LABEL		[V0H0_LABEL_change];
	ITEMS
	{
		trans1_flowrate,
		func1_pv_lower_range_value (READ_ONLY),
		func1_pv_upper_range_value (READ_ONLY)
	}
}

VARIABLE trans1_flowrate
{
	LABEL		[V0H0_LABEL_change];
	HELP		[V0H0_LABEL_change_help];
	CLASS		OUTPUT & DYNAMIC;
	TYPE		FLOAT
	{
		DISPLAY_FORMAT	DEF_DISPLAY_FORMAT_FUNC1_AI
	}

	HANDLING	READ;
}

VARIABLE trans1_tb_unit_volume
{
	LABEL		[V0H3_LABEL_change];	
	HELP		[V0H3_LABEL_change_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED (2)
	{
		DEFAULT_VALUE	43 ;
		{ 43,	[CuMtr] },
		{ 41,	[liter] },
		{ 236, "hl"		},
		{ 40,	[gal]	},
		{ 46,	[bbl]	},	
		{ 244,  "kgal"	},
		{ 112,  [CuFt]	},	
	}
}


VARIABLE phys_actual_error_code
{
	LABEL		[V7H4_LABEL_change];
	HELP		[V7H4_LABEL_change_help];
	CLASS		CONTAINED;
	TYPE		ENUMERATED(2)

	{
		DEFAULT_VALUE	0 ;

		{ C_SYSTEM_OK					,	[enum_c_system_ok]			},
		{ C_POS_ZERO_RET				,	[enum_c_pos_zero_ret]		},
		{ C_SIM_ACTIV					,	[enum_c_sim_activ]			},
		{ C_SIM_IMP_FRQ_ACTIV			,	[enum_c_sim_Imp_Freq_activ]	},
		{ C_SYS_POWER_SUPLY1			,	[enum_c_sys_err_Powersupply]},
		{ C_SYS_POWER_SUPLY2			,	[enum_c_sys_err_Powersupply]},
		{ C_SYS_ERR_AMP1				,	[enum_sys_err_amplifier]	},
		{ C_SYS_ERR_AMP2				,	[enum_sys_err_amplifier]	},
		{ C_SYS_ERR_AMP3				,	[enum_sys_err_amplifier]	},
		{ C_SYS_ERR_AMP4				,	[enum_sys_err_amplifier]	},
		{ C_SYS_ERR_AMP5				,	[enum_sys_err_amplifier]	},
		{ C_SYS_ERR_COM_MODUL1			,	[enum_sys_err_Com_Modul]	},
		{ C_SYS_ERR_COM_MODUL2			,	[enum_sys_err_Com_Modul]	},
		{ C_SYS_ERR_COM_MODUL3			,	[enum_sys_err_Com_Modul]	},
		{ C_SYS_ERR_COM_MODUL4			,	[enum_sys_err_Com_Modul]	},
		{ C_SYS_ERR_COM_MODUL5			,	[enum_sys_err_Com_Modul]	},
		{ C_SYS_ERR_COM_MODUL6			,	[enum_sys_err_Com_Modul]	},
		{ C_VALUE_NOT_USED				,	[enum_value_not_used]		},
		{ C_EPD_TRIM_MIS				,	[enum_epd_trims_missing]	},
		{ C_EPD_TRIM_IMPAS				,	[enum_epd_trims_disabled]	},
		{ C_EPD_FULL_EMPTY1				,	[enum_epd_full_empty]		},
		{ C_EPD_FULL_EMPTY2				,	[enum_c_com_hw_type]		},
		{ C_EMP_PIPE					,	[enum_c_empty_pipe]			},
		{ C_MESURE_LARGE				,	[enum_mesure_large]			},
		{ C_CURR_OUT_HI_LEVEL			,	[enum_c_output_hi_level]	},
		{ C_FREQ_OUT_HI_LEVEL			,	[enum_c_freq_hi_level]		},
		{ C_TIME_OVER					,	[enum_c_time_overflow]		},
		{ C_EPD_RUN1					,	[enum_epd_trims_running]	},
		{ C_EPD_RUN2					,	[enum_epd_trims_running]	},

	}

	HANDLING	READ;
}
/* Bi V1.5 start
MENU Tab_s_interface
{
	LABEL		[menu_interface];
	ITEMS
	{
		help_tb_tot_reset,//Change001
		trans1_tb_assign_disp_line1		(READ_ONLY),
		trans1_tb_assign_disp_line2		(READ_ONLY),
		trans1_tb_display_damping		(READ_ONLY),
		trans1_tb_display_form_flow		(READ_ONLY),
		trans1_tb_display_contrast		(READ_ONLY),
		trans1_tb_assign_language		(READ_ONLY)
	}
}

MENU Tab_m_interface
{
	LABEL		[menu_interface];
	ITEMS
	{
		help_tb_tot_reset,//Change001
		trans1_tb_assign_disp_line1		(READ_ONLY),
		trans1_tb_assign_disp_line2		(READ_ONLY),
		trans1_tb_display_damping		(READ_ONLY),
		trans1_tb_display_form_flow		(READ_ONLY),
		trans1_tb_display_contrast		(READ_ONLY),
		trans1_tb_assign_language		(READ_ONLY)
	}
}
Bi V1.5 end*/


VARIABLE help_trans1_flowrate
{
	LABEL		[V0H0_LABEL_change];
	HELP		[V0H0_LABEL_change_help];
	CLASS		LOCAL;
	TYPE		ENUMERATED(1)
	{
		DEFAULT_VALUE	0;
		{ 0,    	[menu_trans1_flowrate]			},
	}
	HANDLING	READ;
}

VARIABLE help_trans1_tb_tot_1
{
	LABEL		[V0H1_LABEL_change];
	HELP		[V0H1_LABEL_change_help];
	CLASS		LOCAL;
	TYPE		ENUMERATED(1)
	{
		DEFAULT_VALUE	0;
		{ 0,    	[menu_trans1_flowrate]			},
	}
	HANDLING	READ;
}

//Change001 start
VARIABLE help_tb_tot_reset
{
	LABEL		[V5H1_LABEL_change];
	HELP		[V5H1_LABEL_change_help];
	CLASS		LOCAL;
	TYPE		ENUMERATED(1)
	{
		DEFAULT_VALUE	0;
		{ 0,    	[enum_tot_reset]			},
	}
	HANDLING	READ;
}
//Change001 end
